section .data              
;Cambiar Nombre y Apellido por vuestros datos.
developer db "_Nombre_ Apellido_"

;Constantes que también están definidas en C.
DimVector equ 6		

section .text            
;Variables definidas en Ensamblador.
global developer                        

;Subrutinas de ensamblador que se llaman desde C.
global getSecretPlayP1, checkSecretP1, printTriesP1,
global checkPlayP1, printSecretP1, printMessageP1, playP1

;Variables definidas en C.
extern charac, rowScreen, colScreen
extern vSecret, vPlay, tries, state

;Funciones de C que se llaman desde ensamblador
extern clearScreen_C, gotoxyP1_C, printchP1_C, getchP1_C
extern printBoardP1_C, printMessageP1_C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ATENCIÓN: Recordad que las variables y los parámetros de tipo 'char',
;;   en ensamblador se tienen que asignar a registros de tipo BYTE 
;;   (1 byte): al, ah, bl, bh, cl, ch, dl, dh, sil, dil, ...
;;   y los de tipo 'int' se tienen que asignar a registros 
;;   de tipo DWORD (4 bytes): eax, ebx, ecx, edx, esi, edi, ....
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Las subrutinas en ensamblador que tenéis que implementar son:
;;   getSecretPlayP1, checkSecretP1, printTriesP1,  
;;   checkPlayP1, printSecretP1  
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Esta subrutina se da hecha. NO LA PODÉIS MODIFICAR.
; Situar el cursor en la fila indicada por la variable (rowScreen) y 
; en la columna indicada por la variable (colScreen) de la pantalla, 
; llamando a la función gotoxyP1_C.
;
; Variables globales utilizadas:	
; rowScreen: fila de la pantalla donde posicionamos el cursor.
; colScreen: columna de la pantalla donde posicionamos el cursor.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
gotoxyP1:
   push rbp
   mov  rbp, rsp
   ;guardamos el estado de los registros del procesador porque
   ;las funciones de C no mantienen el estado de los registros.
   push rax
   push rbx
   push rcx
   push rdx
   push rsi
   push rdi
   push r8
   push r9
   push r10
   push r11
   push r12
   push r13
   push r14
   push r15

   call gotoxyP1_C
 
   pop r15
   pop r14
   pop r13
   pop r12
   pop r11
   pop r10
   pop r9
   pop r8
   pop rdi
   pop rsi
   pop rdx
   pop rcx
   pop rbx
   pop rax

   mov rsp, rbp
   pop rbp
   ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Esta subrutina se da hecha. NO LA PODÉIS MODIFICAR.
; Mostrar un carácter guardado en la variable (charac) en la pantalla, 
; en la posición donde está el cursor, llamando a la función printchP1_C
; 
; Variables globales utilizadas:	
; charac   : carácter que queremos mostrar.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
printchP1:
   push rbp
   mov  rbp, rsp
   ;guardamos el estado de los registros del procesador porque
   ;las funciones de C no mantienen el estado de los registros.
   push rax
   push rbx
   push rcx
   push rdx
   push rsi
   push rdi
   push r8
   push r9
   push r10
   push r11
   push r12
   push r13
   push r14
   push r15

   call printchP1_C
 
   pop r15
   pop r14
   pop r13
   pop r12
   pop r11
   pop r10
   pop r9
   pop r8
   pop rdi
   pop rsi
   pop rdx
   pop rcx
   pop rbx
   pop rax

   mov rsp, rbp
   pop rbp
   ret
   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Esta subrutina se da hecha. NO LA PODÉIS MODIFICAR.
; Leer una tecla y guardar el carácter asociado a la variable (charac)
; sin mostrarlo por pantalla, llamando a la función getchP1. 
; 
; Variables globales utilizadas:	
; charac   : carácter que leemos de teclado.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
getchP1:
   push rbp
   mov  rbp, rsp
   ;guardamos el estado de los registros del procesador porque
   ;las funciones de C no mantienen el estado de los registros.
   push rax
   push rbx
   push rcx
   push rdx
   push rsi
   push rdi
   push r8
   push r9
   push r10
   push r11
   push r12
   push r13
   push r14
   push r15

   call getchP1_C
 
   pop r15
   pop r14
   pop r13
   pop r12
   pop r11
   pop r10
   pop r9
   pop r8
   pop rdi
   pop rsi
   pop rdx
   pop rcx
   pop rbx
   pop rax
   
   mov rsp, rbp
   pop rbp
   ret 





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Si (state=0) leer la combinación secreta y la guradaremos
; en el vector vSecret, sino estaremos leyendo una jugada y la
; guardaremos en el vector vPlay, son vectores de de DimVector(6) posiciones.
; 
; · Primero indicar la posición del cursor en pantalla 
;   Si (state=0) (rowScreen=3), sino (rowScreen=9+(DimVector-tries)*2)
;   (colScreen=8)
; · Inicializar con espacios el vector (vSecret) si (state=0), si no
;   inicializar con espacios el vector (vPlay).
; Mientras no se pulse ENTER(10) o ESC(27) hacer lo siguiente:
; · Posicionar el cursor en pantalla llamando a la subrutina gotoxyP1, 
;   según el valor de las variables (rowScreen y colScreen).
; · Leer un carácter de teclado llamando la subrutina getchP1
;   que deja en la variable (charac) el código ASCII del carácter leído.
;    - Si se ha leído una 'j'(izquierda) o una 'k' (derecha) mover el 
;      cursor por las 6 posiciones de la combinación, actualizando 
;      el índice del vector (i +/-1) y la columna (colScreen +/-2).
;      (no se puede salir de la zona donde estamos escribiendo (6 posiciones))
;    - Si se ha leído un carácter válido ['0'-'9'] lo guardamos en el vector.
;        Si (state=0) lo guardaremos en el vector (vSecret) y pondremos un '*'
;        en (charac) para que no se vea la combinació secreta,
;        sino lo guardamos en el vector (vPlay).
;      Y mostramos el carácter (charac) en pantalla en la posición donde 
;      está el cursor llamando a la subrutina printchP1.
; · Si se ha pulsado ESC(27) poner (state=7) para indicar que tenemos 
;   que salir.
; 
; Si se pulsa ENTER(10) aceptar la combinación tal y como esté.
; NOTA: Hay que tener en cuenta que si se pulsa ENTER sin haber asignado
; valores a todas las posiciones del vector, habrá posiciones que serán
; un espacio (valor utilizado para inicialitar los vectores).
; 
; Variables globales utilizadas:	
; rowScreen: fila de la pantalla donde posicionamos el cursor.
; colScreen: columna de la pantalla donde posicionamos el cursor.
; charac   : carácter que leemos de teclado.
; vSecret  : vector donde guardamos la combinación secreta
; state    : estado del juego.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
getSecretPlayP1:
   push rbp
   mov  rbp, rsp
	
   

   mov rsp, rbp
   pop rbp
   ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Verifica que la combinación secreta (vSecret) no tenga espacios.
; Para cada elemento del vector (vSecret) mirar que no haya un espacio.
; Si la combinación secreta es correcta, poner (state=1) para indicar 
; que la combinación secreta es correcta y que vamos a leer jugadas.
; Si la combinación secreta es incorrecta, poner (state=3) para volverla
; a pedir sin inicializarla.
; 
; Variables globales utilizadas:	
; vSecret  : vector donde guardamos la combinación secreta
; state    : estado del juego.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
checkSecretP1:
   push rbp
   mov  rbp, rsp
	
   

   mov rsp, rbp
   pop rbp
   ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mostrar los intentos que quedan (tries) para acertar la combinaciónn 
; secreta. 
; Situar el cursor en la fila 23, columna 5 llamando a la subrutina gotoxyP1.
; Mostrar el carácter asociado al valor de la variable (tries) 
; llamando a la subrutina printchP1.
; Para obtener el carácter asociado a los intentos, código ASCII del número,
; hay que sumar al valor numérico de los intentos (tries) 48 (código 
; ASCII de '0'). (charac=tries+'0' o charac=tries+48).
; 
; Variables globales utilizadas:	
; rowScreen: fila de la pantalla donde posicionamos el cursor.
; colScreen: columna de la pantalla donde posicionamos el cursor.
; charac   : carácter que leemos de teclado.
; tries    : número de intentos que quedan.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
printTriesP1:
   push rbp
   mov  rbp, rsp
	
   

   mov rsp, rbp
   pop rbp
   ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mirar si la jugada (vPlay) es igual (posición a posición) a la 
; combinación secreta (vSecret), para cada posición que sea igual
; incrementar los aciertos en el sitio (hitsX++).
; Si todas las posiciones de la combinación secreta (vSecret) y de la jugada
; (vPlay) son iguales (hitsX=6) hemos ganado (state=5).
; 
; Variable Local de C (en ensamblador utilizar un registro):
; hitsX    : aciertos en el sitio.
;
; Variables globales utilizadas:	
; vSecret  : vector donde guardamos la combinación secreta
; vPlay    : vector donde guardamos cada jugada.
; state    ; estado del juego.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
checkPlayP1:
   push rbp
   mov  rbp, rsp
	
   

   mov rsp, rbp
   pop rbp
   ret
   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Mostrar la combinación secreta en la parte superior del tablero 
; cuando finaliza el juego.
; 
; Variables globales utilizadas:	
; rowScreen: fila de la pantalla donde posicionamos el cursor.
; colScreen: columna de la pantalla donde posicionamos el cursor.
; charac   : carácter que leemos de teclado.
; vSecret  : vector donde guardamos la combinación secreta.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
printSecretP1:
   push rbp
   mov  rbp, rsp
	
   

   mov rsp, rbp
   pop rbp
   ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Esta subrutina se da hecha. NO LA PODÉIS MODIFICAR.
; Muestra un mensaje debajo del tablero según el valor de la variable
; (state) llamando la función printMessageP1_C.
; (state)  0: Estamos entrando la combinación secreta, 
;          1: Estamos entrando la jugada.
;          3: La combinación secreta tiene espacios o números repetidos.
;          5: Se ha ganado, jugada = combinación secreta.
;          6: Se han agotado las jugadas
;          7: Se ha pulsado ESC para salir
; Se espera que se pulse una tecla para continuar. Mostrando un mensaje
; debajo del tablero para indicarlo y al pulsar una tecla lo borra.
;         
; Variables globales utilizadas:	
; Ninguna
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
printMessageP1:
   push rbp
   mov  rbp, rsp
   ;guardamos el estado de los registros del procesador porque
   ;las funciones de C no mantienen el estado de los registros.
   push rax
   push rbx
   push rcx
   push rdx
   push rsi
   push rdi
   push r8
   push r9
   push r10
   push r11
   push r12
   push r13
   push r14
   push r15

   ;Llamamos a la función printMessageP1_C() des de ensamblador, 
   call printMessageP1_C
 
   pop r15
   pop r14
   pop r13
   pop r12
   pop r11
   pop r10
   pop r9
   pop r8
   pop rdi
   pop rsi
   pop rdx
   pop rcx
   pop rbx
   pop rax

   mov rsp, rbp
   pop rbp
   ret
   
   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Esta subrutina se da hecha. NO LA PODÉIS MODIFICAR.
; Subrutina principal del juego
; Leer la combinación secreta y verificar que sea correcta.
; A continuación se lee una jugada, compara la jugada con la
; combinación secreta para determinar si son iguales.
; repetir el proceso mientras no se acierta la combinación secreta y 
; mientras queden intentos. Si se pulsa la tecla 'ESC' durante la 
; lectura de la combinación secreta o de una jugada salir.
; 
; Pseudo código:
; El jugador tiene que disponer de 6 intentos para acertar la combinación 
; secreta y el estado inicial del juego es 0.
; Mostrar el tablero de juego llamando a la función printBoardP1_C.
; Mostrar un mensaje indicando que se tiene que entrar la combinación 
; secreta llamando a la subrutina printMessageP1;
; Mientras (state=0) leer combinación secreta o (state=3) se ha leído 
; la combinación secreta pero no es correcta:
;   - Poner el estado inicial del juego a 0 (state=0) .
;   - Leer la combinación secreta llamando la subrutina getSecretPlayP1.
;   - Si no se ha pulsado la tecla (ESC) (state!=7) llamar a la subrutina 
;     checkSecretP1 para verificar si la combinación secreta tiene 
;     espacios i mostar un mensaje llamando a la subrutina printMessageP1
;     indicando que la combinación secreta no és correcta (state=3) o
;     que ya se pueden entrar jugadas (state=1). 
; Mientras (state=1) estamos introduciendo jugadas:
;   - Mostrar los intentos que queden llamando a la subrutina printTriesP1.
;   - Leer la jugada llamando a la subrutina getSecretPlayP1.
;   - Si no se ha pulsado (ESC) (state!=7) llamar a la subrutina chekHitsP1 
;     para mirar si la jugada (vPlay) es igual (posición a posición) a la 
;     combinación secreta (vSecret), si es igual (state=5).
;     Decrementamos los intentos, y si no quedan intentos (tries=0) y 
;     no hemos acertado la combinación secreta (state=1), hemos 
;     perdido (state=6).
; Para acabar, mostrar la combinación secreta llamando a la subrutina
; printSecretP1 y un mensaje indicando cual ha sido el motivo
; llamando a la subrutina printMessageP1.
; Se acaba el juego.
; 
; Variables globales utilizadas:	
; tries    : número de intentos que quedan.
; state    : estado del juego.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
playP1:
   push rbp
   mov  rbp, rsp

   mov  DWORD[tries], 6  ;tries = 6;
   mov  DWORD[state], 0  ;state = 0;
   call printBoardP1_C   ;printBoardP1_C();
   call printMessageP1   ;printMessageP1_C();
 
   p1_while0:       ;while (state == 0 || state==3) {
   cmp DWORD[state], 0
   je  p1_while0_ok
   cmp DWORD[state], 3
   jne p1_while0_end
     p1_while0_ok:
     mov  DWORD[state], 0    ;state = 0;
	 call getSecretPlayP1    ;getSecretPlayP1_C();
	 p1_if1:                 ;if (state!=7) {
	 cmp DWORD[state], 7
	 je p1_if1_end
	   call checkSecretP1      ;checkSecretP1_C();
	   call printMessageP1     ;printMessageP1_C();
	 p1_if1_end:
	 
     jmp p1_while0
   p1_while0_end:
   
   p1_while1:       ;while (state==1) {
   cmp DWORD[state], 1
   jne p1_while1_end
	 call printTriesP1    ;printTriesP1_C();
	 call getSecretPlayP1 ;getSecretPlayP1_C();
	 p1_if2:              ;if (state!=7) {
	 cmp DWORD[state], 7
	 je p1_if2_end
	   call checkPlayP1  ;checkPlayP1_C();
	   dec DWORD[tries]  ;tries--;
	   p1_if3:           ;if (tries == 0 && state == 1) {
	   cmp DWORD[tries], 0
	   jne p1_if3_end
	   cmp DWORD[state], 1
	   jne p1_if3_end
         mov DWORD[state], 6  ;state = 6;
       p1_if3_end:
     p1_if2_end:
     jmp p1_while1
   p1_while1_end:
   call printSecretP1    ;printSecretP1_C();
   call printMessageP1   ;printMessageP1_C();
   
   p1_end:	
   mov rsp, rbp
   pop rbp
   ret
